﻿Imports Telerik.Web.UI
Imports Telerik.OpenAccess
Imports PersistentClasses

Partial Class Views
    Inherits System.Web.UI.UserControl

    Private viewItemsList As IDictionary(Of String, String) = New Dictionary(Of String, String)()

    Protected Sub Page_Init(ByVal sender As Object, ByVal e As EventArgs)
        Me.InitViewList()
        Me.InitComboBox()
    End Sub

    Private Sub InitViewList()
        Me.viewItemsList.Add("AlphabeticalListOfProduct", "Alphabetical list of product")
        Me.viewItemsList.Add("CategorySalesFor1997", "Category Sales for 1997")
        Me.viewItemsList.Add("CurrentProductList", "Current Product list")
        Me.viewItemsList.Add("CustomerAndSuppliersByCity", "Customer and Suppliers by City")
        Me.viewItemsList.Add("Invoice", "Invoices")
        Me.viewItemsList.Add("OrderDetailsExtended", "Order Details Extended")
        Me.viewItemsList.Add("OrderSubtotal", "Order Subtotal")
        Me.viewItemsList.Add("OrdersQry", "Orders Qry")
        Me.viewItemsList.Add("ProductSalesFor1997", "Product Sales for 1997")
        Me.viewItemsList.Add("ProductsAboveAveragePrice", "Products Above Average Price")
        Me.viewItemsList.Add("ProductsByCategory", "Products by Category")
        Me.viewItemsList.Add("QuarterlyOrder", "Quarterly Order")
        Me.viewItemsList.Add("SalesTotalsByAmount", "Sales Totals by Amount")
        Me.viewItemsList.Add("SalesByCategory", "Sales by Category")
        Me.viewItemsList.Add("SummaryOfSalesByQuarter", "Summary of Sales by Quarter")
        Me.viewItemsList.Add("SummaryOfSalesByYear", "Summary of Sales by Year")
    End Sub

    Private Sub InitComboBox()
        RadComboBox1.DataSource = Me.viewItemsList
        RadComboBox1.DataTextField = "Value"
        RadComboBox1.DataValueField = "Key"
        RadComboBox1.DataBind()
    End Sub

    Protected Sub OnSelectedIndexChanged(ByVal o As Object, ByVal e As RadComboBoxSelectedIndexChangedEventArgs)
        RadGrid1.CurrentPageIndex = 0
        Me.BindViewData()
        RadGrid1.Rebind()
    End Sub

    Private Sub BindViewData()
        Dim viewName As String = RadComboBox1.SelectedItem.Value

        Dim scope As IObjectScope = ScopeFactory.GetScope(HttpContext.Current)
        Dim query As String = String.Format("SELECT * FROM {0}Extent", viewName)
        Dim result As IQueryResult = scope.GetOqlQuery(query).Execute()

        RadGrid1.DataSource = result.ToList()
    End Sub

    Protected Sub OnNeedDataSource(ByVal source As Object, ByVal e As GridNeedDataSourceEventArgs)
        Me.BindViewData()
    End Sub

End Class
